#include "main.h"

Widget DisplayWeeklyView_SW;
Widget DisplayWeeklyView_DA;
Widget DisplayWeeklyView_Label;
Pixmap DisplayWeeklyView_Pixmap;
GC GraphicContext;
XGCValues GraphicContextValues;

int G_Start_Of_Week;

int LastX,LastY,LastWidth,LastHeight;

typedef struct WeekBox_Struct {
  int x,y,width,height;
  int day;
  int month;
  int year;
} WeekBox_Type;

WeekBox_Type WeekBoxList[8];

void DEBUG_PrintCalendar(int *days)
{
  int lcv, lcv2;
  for (lcv = 0,lcv2= 1; lcv < 42;lcv++,lcv2++)
    {
      fprintf(stderr,"%-3d ",days[lcv]);
      if (lcv2 == 7)
	{
	  lcv2 = 0;
	  fprintf(stderr,"\n");
	}
    }
}

void Get_Week(int Current_Day,
	      int Current_Month,
	      int Current_Year,
	      int *cdays,
	      int *cmonth,
	      int *cyear,
	      int *Start_Day,
	      int *Start_Month,
	      int *Start_Year)

{
  int StartOfMonth, StartOfMonth_pos;
  int EndOfMonth, EndOfMonth_pos, PrevEndOfMonth_pos, NextStartOfMonth_pos;
  int pdays[42],ndays[42];
  int current_day_pos;
  int prev_year, prev_month;
  int next_year, next_month;
  int lcv, lcv2;
  int Old_Julian = 0;

  Old_Julian = G_Julian;
  G_Julian = 0;
  day_array(Current_Month, Current_Year, cdays);
  for (lcv=0;lcv < 42; lcv++)
    {
      cmonth[lcv] = Current_Month;
      cyear[lcv] = Current_Year;
    }
  for (lcv=41;lcv > -1; lcv--)
    {
      if (cdays[lcv] != -1)
	{
	  EndOfMonth = cdays[lcv];
	  EndOfMonth_pos = lcv;
	  break;
	}
    }
  for (lcv=0;lcv < 42; lcv++)
    {
      if (cdays[lcv] != -1)
	{
	  StartOfMonth = cdays[lcv];
	  StartOfMonth_pos = lcv;
	  break;
	}
    }
/*   printf("StartOfMonth=%d EndOfMonth=%d StartOfMonth_pos=%d EndOfMonth_pos=%d\n", */
/* 	 StartOfMonth,EndOfMonth,StartOfMonth_pos,EndOfMonth_pos); */
  for (lcv=0;lcv < 42; lcv++)
    {
      if (cdays[lcv] == Current_Day)
	{
	  current_day_pos = lcv;
	  break;
	}
    }
  prev_month = Current_Month - 1;
  prev_year = Current_Year;
  next_month = Current_Month + 1;
  next_year = Current_Year;
  
  if (prev_month < 1)
    {
      prev_month = 12;
      prev_year = Current_Year - 1;
    }

  if (next_month > 12)
    {
      next_month = 1;
      next_year = Current_Year + 1;
    }
  day_array(prev_month, prev_year, pdays);
  day_array(next_month, next_year, ndays);

/*   printf("StartOfMonth=%d EndOfMonth=%d StartOfMonth_pos=%d EndOfMonth_pos=%d\n", */
/* 	 StartOfMonth,EndOfMonth,StartOfMonth_pos,EndOfMonth_pos); */

  for (lcv=41;lcv > -1; lcv--)
    {
      if (pdays[lcv] != -1)
	{
	  PrevEndOfMonth_pos = lcv;
	  break;
	}
    }
  for (lcv=0;lcv < 42; lcv++)
    {
      if (ndays[lcv] != -1)
	{
	  NextStartOfMonth_pos = lcv;
	  break;
	}
    }
/*   fprintf(stderr,"PrevEndOfMonth_pos=%d    NextStartOfMonth_pos=%d\n", */
/* 	  PrevEndOfMonth_pos,NextStartOfMonth_pos); */

  
  lcv2 = StartOfMonth_pos - 1;
  for (lcv=PrevEndOfMonth_pos;lcv2 >= 0; lcv--, lcv2--)
    {
      cdays[lcv2] = pdays[lcv];
      cmonth[lcv2] = prev_month; 
      cyear[lcv2] = prev_year;
    }

  lcv2 = EndOfMonth_pos + 1;
  for (lcv=NextStartOfMonth_pos;lcv2 < 42; lcv++, lcv2++)
    {
/*       fprintf(stderr,"%d,%d %d,%d\n",cdays[lcv2],lcv2,pdays[lcv],lcv); */
      cdays[lcv2] = ndays[lcv];
      cmonth[lcv2] = next_month; 
      cyear[lcv2] = next_year;
    }

  *Start_Day = cdays[current_day_pos - (current_day_pos%7)];
  if ((current_day_pos - (current_day_pos%7)) < StartOfMonth_pos)
    {
      *Start_Month = prev_month;
      *Start_Year = prev_year;
    }
  else {
      *Start_Month = Current_Month;
      *Start_Year = Current_Year;
  }
/*   DEBUG_PrintCalendar(cdays); */
  G_Julian = Old_Julian;
}



void DrawWeeklyCalendar()
{
  Pixel FG;
  int lcv, lcv2,lcv3,lcv4,lcv5;
  int BoxNum, MinsLeft,NumTextLines, BoxPart, DayBox;
  Dimension Height = 0;
  Dimension Width = 0;
  int HOffset = 0;
  int WOffset = 0;
  XmString LabelString;
  char LabelBuffer[MY_BUFSIZ+1];
  int days[42];
  int daysmonth[42];
  int daysyear[42];
  int Start_Day;
  int Start_Month;
  int Start_Year;
  int current_day_pos;
  int Old_Julian = 0;
  int weekday = 0;
  Calendar_Type *Temp;
  Appointment_Type *ATemp;
  char Buffer[MY_BUFSIZ+1];
  XCharStruct CharStruct;
  int CharHeight,CharWidth;
  
  XTextExtents(G_YearWeekFontStruct,Unix_Filename_Chars_CONST,
	       strlen(Unix_Filename_Chars_CONST),&lcv,&lcv,&lcv,&CharStruct);
  CharHeight = CharStruct.ascent + CharStruct.descent;
/*   fprintf(stderr,"CharHeight=%d \n",CharHeight); */

  Old_Julian = G_Julian;
  G_Julian = 0;
  day_array(G_Current_Month, G_Current_Year, days);
  G_Julian = Old_Julian;
  for (lcv=0;lcv < 42; lcv++)
    {
      if (days[lcv] == G_Current_Day)
        {
          current_day_pos = lcv;
          break;
        }
    }

  Get_Week(G_Current_Day,G_Current_Month,G_Current_Year,days,
	   daysmonth,daysyear,&Start_Day,&Start_Month,&Start_Year);
  
/*   DEBUG_PrintCalendar(days); */

  /* get size of drawing area */

  XtVaGetValues(DisplayWeeklyView_DA,
		XmNwidth, &Width,
		XmNheight, &Height,
		NULL,0);
/*   fprintf(stderr,"drawing area: width=%d height=%d\n",Width,Height); */

  /* create graphic context */

  GraphicContextValues.font = G_YearWeekFontStruct->fid; 
  GraphicContextValues.foreground = BlackPixelOfScreen(XtScreen(DisplayWeeklyView_DA));
  GraphicContextValues.background = WhitePixelOfScreen(XtScreen(DisplayWeeklyView_DA));
  GraphicContextValues.fill_style = FillSolid;
  GraphicContext = XCreateGC(XtDisplay(DisplayWeeklyView_DA), 
			     RootWindowOfScreen(XtScreen(DisplayWeeklyView_DA)),
			     GCForeground|GCBackground|GCFillStyle|GCFont,
			     &GraphicContextValues);

  
  XtVaSetValues(DisplayWeeklyView_DA,
		XmNuserData,GraphicContext,
		NULL,0);
  

  /* clear window & pixmap */
  
	     
  FG = GraphicContextValues.foreground;
  XSetForeground(XtDisplay(DisplayWeeklyView_DA),GraphicContext,GraphicContextValues.background);
  XSetFillStyle(XtDisplay(DisplayWeeklyView_DA),GraphicContext,FillSolid);
  XFillRectangle(XtDisplay(DisplayWeeklyView_DA),DisplayWeeklyView_Pixmap,
		 GraphicContext,0,0,Width,Height);
  XSetForeground(XtDisplay(DisplayWeeklyView_DA),GraphicContext,FG);
  
  XClearWindow(XtDisplay(DisplayWeeklyView_DA),
	       XtWindow(DisplayWeeklyView_DA));


  /* draw calendar */
  WOffset = (Width-40)/7;
  LastX = 0;
  weekday = current_day_pos - (current_day_pos%7);
  for (lcv= 0; lcv <= 7; lcv++,weekday++)
    {
/*       fprintf(stderr,"WOffset=%d LastX=%d\n",WOffset,LastX); */
      if (lcv == 0)
	{
	  XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
			 XtWindow(DisplayWeeklyView_DA),
			 GraphicContext,
			 0,
			 20,
			 50,
			 Height-10);
	  XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
			 DisplayWeeklyView_Pixmap,
			 GraphicContext,
			 0,
			 20,
			 50,
			 Height-10);
	  XDrawString(XtDisplay(DisplayWeeklyView_DA),
		      XtWindow(DisplayWeeklyView_DA),
		      GraphicContext,
		      15,
		      15,
		      "Time",
		      strlen("Time"));
	  XDrawString(XtDisplay(DisplayWeeklyView_DA),
		      DisplayWeeklyView_Pixmap,
		      GraphicContext,
		      15,
		      15,
		      "Time",
		      strlen("Time"));
	  LastX = 50-WOffset;
	}
      else {
	WeekBoxList[lcv].x = LastX+WOffset;
	WeekBoxList[lcv].y = 20;
	WeekBoxList[lcv].width = WOffset;
	WeekBoxList[lcv].height = Height-10;
	WeekBoxList[lcv].day = days[weekday-1];
	WeekBoxList[lcv].month = daysmonth[weekday-1];
	WeekBoxList[lcv].year = daysyear[weekday-1];
	XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
		       XtWindow(DisplayWeeklyView_DA),
		       GraphicContext,
		       LastX+WOffset,
		       20,
		       WOffset,
		       Height-10);
	XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
		       DisplayWeeklyView_Pixmap,
		       GraphicContext,
		       LastX+WOffset,
		       20,
		       WOffset,
		       Height-10);
	sprintf(LabelBuffer,"%s %s %d",G_DaysOfWeek[lcv-1],
		G_ShortMonthNames[daysmonth[weekday-1]-1],days[weekday-1]);
	XDrawString(XtDisplay(DisplayWeeklyView_DA),
		    DisplayWeeklyView_Pixmap,
		    GraphicContext,
		    LastX+WOffset+(WOffset/3),
		    15,
		    LabelBuffer,
		    strlen(LabelBuffer));
	LastX = LastX+WOffset;
      }
    }
  for (lcv =0;lcv <= 23;lcv++)
    {
      sprintf(LabelBuffer,"%0-2d:00",lcv);
      if ((lcv == 6) || (lcv == 17))
	{
	  XDrawString(XtDisplay(DisplayWeeklyView_DA),
		      DisplayWeeklyView_Pixmap,
		      GraphicContext,
		      16,
		      (lcv*40)+35,
		      LabelBuffer,
		      strlen(LabelBuffer));
	}
      XDrawString(XtDisplay(DisplayWeeklyView_DA),
		  DisplayWeeklyView_Pixmap,
		  GraphicContext,
		  15,
		  (lcv*40)+35,
		  LabelBuffer,
		  strlen(LabelBuffer));
      if (G_CalendarList != NULL)
	{
	  for (lcv2=1;lcv2 <= 7;lcv2++)
	    {
	      Temp = G_CalendarList;
	      while (Temp != NULL)
		{
		  if ((WeekBoxList[lcv2].day == Temp->Day) &&
		      (WeekBoxList[lcv2].month == Temp->Month) &&
		      (WeekBoxList[lcv2].year == Temp->Year))
		    {
		      ATemp = Temp->Appointments;
			while (ATemp != NULL)
			  {
			    if (lcv == ATemp->Hour)
			      {
/*  				fprintf(stderr,"Found %d/%d/%d at %d hrs\n",WeekBoxList[lcv2].month,  */
/* 					WeekBoxList[lcv2].day,WeekBoxList[lcv2].year,lcv);  */
				MinsLeft = (ATemp->Length_Hours*60) + ATemp->Length_Minutes;
				BoxPart = 13;
				NumTextLines = 0;
				DayBox = lcv2;
				for (BoxNum=lcv; MinsLeft > 0 ;MinsLeft -= 20,BoxPart += 13,NumTextLines++)
				  {
				    if (BoxPart > 40)
				      {
					BoxPart = 13;
					BoxNum++;
/* 					fprintf(stderr,"** BoxNum=%d BoxPart=%d MinsLeft=%d hour=%d\n", */
/* 						BoxNum,BoxPart,MinsLeft,ATemp->Hour); */
				      }
				    if (BoxNum <= 23)
				      {
					XFillRectangle(XtDisplay(DisplayWeeklyView_DA),
						       DisplayWeeklyView_Pixmap,
						       GraphicContext,
						       WeekBoxList[DayBox].x,
						       (BoxNum*40)+23,
						       WeekBoxList[DayBox].width,
						       BoxPart);
				      }
/* 				    fprintf(stderr,"   BoxNum=%d BoxPart=%d MinsLeft=%d hour=%d\n", */
/* 					    BoxNum,BoxPart,MinsLeft,ATemp->Hour); */
				  }
				XSetForeground(XtDisplay(DisplayWeeklyView_DA), 
					       GraphicContext,
					       WhitePixelOfScreen(XtScreen(DisplayWeeklyView_DA)));
				
				lcv4 = 0;
				HOffset = 0;
				for (lcv3=0;lcv3 < NumTextLines;lcv3++)
				  {
				    CharWidth = 0;
				    lcv5 = 0;
				    memset(Buffer,'\0',MY_BUFSIZ);
				    while ((CharWidth < (WeekBoxList[lcv2].width-6)) && (lcv4 < strlen(ATemp->Message)))
				      {
					Buffer[lcv5]=ATemp->Message[lcv4];
					Buffer[lcv5+1]='\0';
/* 					fprintf(stderr,"%d-%d-%d:%s\n",lcv3,lcv4,lcv5,Buffer); */
					CharWidth = XTextWidth(G_YearWeekFontStruct,Buffer,strlen(Buffer));
					lcv4++; lcv5++;
				      }
				    lcv4--;
				    if (Buffer[0] != '\0')
				      {
					XDrawString(XtDisplay(DisplayWeeklyView_DA),
						    DisplayWeeklyView_Pixmap,
						    GraphicContext,
						    WeekBoxList[lcv2].x+3,
						    (lcv*40)+23+(CharHeight*(lcv3+1)),
						    Buffer,
						    strlen(Buffer)-1);
				      }
				  }
				XSetForeground(XtDisplay(DisplayWeeklyView_DA), 
					       GraphicContext,
					       BlackPixelOfScreen(XtScreen(DisplayWeeklyView_DA)));
			      }
			    ATemp = ATemp->Next;
			  }
		    }
		  Temp = Temp->Next;
		}
	    }
	}

      if ((lcv == 6) || (lcv == 17))
	{
	  XSetLineAttributes(XtDisplay(DisplayWeeklyView_DA),
			     GraphicContext,
			     3,LineOnOffDash,CapButt,JoinMiter);
	}
      XDrawLine(XtDisplay(DisplayWeeklyView_DA),
		DisplayWeeklyView_Pixmap,
		GraphicContext,
		0,
		(lcv*40)+22,
		Width-1,
		(lcv*40)+22);
      XSetLineAttributes(XtDisplay(DisplayWeeklyView_DA),
			 GraphicContext,
			 1,LineSolid,CapButt,JoinMiter);
    }
  
  XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
		 DisplayWeeklyView_Pixmap,
		 GraphicContext,
		 0,0,Width-1,Height-1);
  
  /* place pixmap onto drawing area */

  XSetWindowBackgroundPixmap(XtDisplay(DisplayWeeklyView_DA),
			     XtWindow(DisplayWeeklyView_DA),
			     DisplayWeeklyView_Pixmap);

  XClearWindow(XtDisplay(DisplayWeeklyView_DA),
	       XtWindow(DisplayWeeklyView_DA));

  /* update year label */

  sprintf(LabelBuffer,"Week Starting %s %d, %d",G_MonthNames[Start_Month-1],Start_Day,Start_Year);
  LabelString = XmStringCreate(LabelBuffer, XmSTRING_DEFAULT_CHARSET),
  XtVaSetValues (DisplayWeeklyView_Label,
		 XmNlabelString, LabelString,
		 NULL,0);
  XmStringFree(LabelString);
}

void DisplayNextWeek()
{
  int days[42];
  int lcv, TempDay;
  int EndOfMonth;

  day_array(G_Current_Month, G_Current_Year, days);
  for (lcv=41;lcv > -1; lcv--)
    {
      if (days[lcv] != -1)
	{
	  EndOfMonth = days[lcv];
	  break;
	}
    }
  TempDay = G_Current_Day;
  TempDay += 7;
  if (TempDay > EndOfMonth)
    {
      G_Current_Day = TempDay - EndOfMonth;
      G_Current_Month++;
      if (G_Current_Month > 12)
	{
	  G_Current_Month = 1;
	  G_Current_Year++;
	}
      if (G_Current_Year > 9999)
	{
	  G_Current_Year = 1;
	}
    }
  else {
      G_Current_Day = TempDay;
  }
  DrawWeeklyCalendar();
  DisplayMonth_Calendar(G_Current_Month,G_Current_Year);
  if (G_DisplayYearlyViewVisible == True)
    {
      DrawYearCalendar();
    }
 if (G_AppointmentFormVisible == True)
    {
      CreateAppointment_Form(G_Current_Day,G_Current_Month,G_Current_Year);
    }
}

void DisplayPreviousWeek()
{
  int days[42];
  int lcv, TempDay;
  int EndOfMonth;

  TempDay = G_Current_Day;
  TempDay -= 7;
  if (TempDay < 1)
    {
      G_Current_Month--;
      if (G_Current_Month < 1)
	{
	  G_Current_Month = 12;
	  G_Current_Year--;
	}
      if (G_Current_Year < 0)
	{
	  G_Current_Year = 9999;
	}
      day_array(G_Current_Month, G_Current_Year, days);
      for (lcv=41;lcv > -1; lcv--)
	{
	  if (days[lcv] != -1)
	    {
	      EndOfMonth = days[lcv];
	      break;
	    }
	}
      G_Current_Day = EndOfMonth + TempDay;
    }
  else {
      G_Current_Day = TempDay;
  }
  DrawWeeklyCalendar();
  DisplayMonth_Calendar(G_Current_Month,G_Current_Year);
  if (G_DisplayYearlyViewVisible == True)
    {
      DrawYearCalendar();
    }
 if (G_AppointmentFormVisible == True)
    {
      CreateAppointment_Form(G_Current_Day,G_Current_Month,G_Current_Year);
    }
}

void DisplaySelectedDay(Widget W,
			XtPointer data,
			XmDrawingAreaCallbackStruct *cbs)
{
  Pixel FG;
  int lcv ;
  int FoundAtPos = -1;
	  
  if ((cbs->event->xany.type != ButtonPress))
    {
      return;
    }
/*    fprintf(stderr,"pointer %d  %d \n",cbs->event->xbutton.x,cbs->event->xbutton.y);  */
  for (lcv = 1;lcv != 8; lcv++)
    {
/*      fprintf(stderr," box #%d %dx%d %dx%d\n",lcv,
	      WeekBoxList[lcv].x,
	      WeekBoxList[lcv].y,
	      (WeekBoxList[lcv].x + WeekBoxList[lcv].width),
	      (WeekBoxList[lcv].y + WeekBoxList[lcv].height));
  */    
      if ((cbs->event->xbutton.x > WeekBoxList[lcv].x) &&
	  (cbs->event->xbutton.y > WeekBoxList[lcv].y) &&
	  (cbs->event->xbutton.x < (WeekBoxList[lcv].x + WeekBoxList[lcv].width)) &
	  (cbs->event->xbutton.y < (WeekBoxList[lcv].y + WeekBoxList[lcv].height)))
	{
	  FoundAtPos = lcv;
	  FG = GraphicContextValues.foreground;
	  XSetForeground(XtDisplay(DisplayWeeklyView_DA),GraphicContext,GraphicContextValues.background);
	  XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
			 DisplayWeeklyView_Pixmap,
			 GraphicContext,
			 LastX+3,
			 LastY+3,
			 LastWidth-6,
			 LastHeight-6);

	  XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
			 XtWindow(DisplayWeeklyView_DA),
			 GraphicContext,
			 LastX+3,
			 LastY+3,
			 LastWidth-6,
			 LastHeight-6);

	  XSetForeground(XtDisplay(DisplayWeeklyView_DA),GraphicContext,FG);
	  
	  XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
			 DisplayWeeklyView_Pixmap,
			 GraphicContext,
			 WeekBoxList[lcv].x+3,
			 WeekBoxList[lcv].y+3,
			 WeekBoxList[lcv].width-6,
			 WeekBoxList[lcv].height-6);

	  XDrawRectangle(XtDisplay(DisplayWeeklyView_DA),
			 XtWindow(DisplayWeeklyView_DA),
			 GraphicContext,
			 WeekBoxList[lcv].x+3,
			 WeekBoxList[lcv].y+3,
			 WeekBoxList[lcv].width-6,
			 WeekBoxList[lcv].height-6);

	  LastX = WeekBoxList[lcv].x;
	  LastY = WeekBoxList[lcv].y;
	  LastWidth = WeekBoxList[lcv].width;
	  LastHeight = WeekBoxList[lcv].height;
/*  	  fprintf(stderr,"found %d\n",lcv);  */
	  G_Current_Month = lcv+1;
	  XSetWindowBackgroundPixmap(XtDisplay(DisplayWeeklyView_DA),
				     XtWindow(DisplayWeeklyView_DA),
				     DisplayWeeklyView_Pixmap);
	}
    }
  if (FoundAtPos == -1)
    {
      return;
    }
  G_Current_Day = WeekBoxList[FoundAtPos].day;
  G_Current_Month = WeekBoxList[FoundAtPos].month;
  G_Current_Year = WeekBoxList[FoundAtPos].year;
  DisplayMonth_Calendar(G_Current_Month,G_Current_Year);
  if (G_AppointmentFormVisible == True)
    {
      CreateAppointment_Form(G_Current_Day,G_Current_Month,G_Current_Year);
    }
  CreateAppointment_Form(G_Current_Day,G_Current_Month,G_Current_Year);
}

void DisplayWeeklyView_Close(Widget   w,
			     Widget   PopupWidget, 
			     XmAnyCallbackStruct *call_value)
{
  G_DisplayWeeklyViewVisible = False;
  XFreePixmap(XtDisplay(DisplayWeeklyView_DA),
	      DisplayWeeklyView_Pixmap);
  XtUnrealizeWidget(PopupWidget); 
}

void DisplayWeeklyView()
{

  Widget DisplayWeeklyView_Popup;
  Widget DisplayWeeklyView_Frame;
  Widget DisplayWeeklyView_Form;
  Widget DisplayWeeklyView_Separator;
  Widget DisplayWeeklyViewClose_Button;
  Widget DisplayWeeklyViewNext_Button;
  Widget DisplayWeeklyViewPrev_Button;
  XmString LabelString;
  char LabelBuffer[MY_BUFSIZ+1];
  int days[42];
  int daysmonth[42];
  int daysyear[42];
  int Start_Day;
  int Start_Month;
  int Start_Year;
  Dimension Height = 0;
  Dimension Width = 0;
  Atom WM_DELETE_WINDOW;

  if (G_YearWeekFontStruct == NULL)
    {
      ErrorMessage("Font Error:\n\nRequired fonts are unavailable.\nUnable to create graphic display.\n");
      return;
    }

  if (G_DisplayWeeklyViewVisible == True)
    {
      DrawWeeklyCalendar();
      return;
    }

  Get_Week(G_Current_Day,G_Current_Month,G_Current_Year,days,
	   daysmonth,daysyear,&Start_Day,&Start_Month,&Start_Year);

  G_DisplayWeeklyViewVisible = True;

  DisplayWeeklyView_Popup = XtVaAppCreateShell("DisplayWeeklyView_Popup",
					       "DisplayWeeklyView_Popup",
					       applicationShellWidgetClass,
					       XtDisplay(W_TopLevel),
					       XmNtitle, "Weekly View",
					       XmNdeleteResponse, XmDO_NOTHING,
					       NULL,0); 
  
  DisplayWeeklyView_Frame = XtVaCreateManagedWidget("DisplayWeeklyView_Frame",
						    xmFrameWidgetClass, 
						    DisplayWeeklyView_Popup,
						    NULL,0);
  
  DisplayWeeklyView_Form = XtVaCreateManagedWidget("DisplayWeeklyView_Form",
						   xmFormWidgetClass, 
						   DisplayWeeklyView_Frame,
						   NULL,0);
  
  DisplayWeeklyViewPrev_Button = XtVaCreateManagedWidget("DisplayWeeklyViewPrev_Button",
							 xmArrowButtonWidgetClass,
							 DisplayWeeklyView_Form,
							 XmNarrowDirection, XmARROW_LEFT,
							 XmNleftAttachment, XmATTACH_POSITION,
							 XmNleftPosition,0,
							 XmNleftOffset,10,
							 XmNrightAttachment, XmATTACH_POSITION,
							 XmNrightPosition,10,
							 XmNtopAttachment, XmATTACH_POSITION,
							 XmNtopPosition, 2,
							 XmNbottomAttachment, XmATTACH_POSITION,
							 XmNbottomPosition, 8,
							 NULL,0);
  XtAddCallback(DisplayWeeklyViewPrev_Button, XmNactivateCallback,  
		(XtCallbackProc)  DisplayPreviousWeek, NULL);


  sprintf(LabelBuffer,"Week Starting %s %d, %d",
	  G_MonthNames[Start_Month-1],Start_Day,Start_Year);
  LabelString = XmStringCreate(LabelBuffer, XmSTRING_DEFAULT_CHARSET),
  DisplayWeeklyView_Label = XtVaCreateManagedWidget("DisplayWeeklyView_Label",
						    xmLabelWidgetClass, 
						    DisplayWeeklyView_Form,
						    XmNlabelString, LabelString,
						    XmNleftAttachment, XmATTACH_POSITION,
						    XmNleftPosition,10,
						    XmNrightAttachment, XmATTACH_POSITION,
						    XmNrightPosition,90,
						    XmNtopAttachment, XmATTACH_POSITION,
						    XmNtopPosition, 0,
						    XmNbottomAttachment, XmATTACH_POSITION,
						    XmNbottomPosition, 10,
						    XmNalignment, XmALIGNMENT_CENTER,
						    NULL,0);
  XmStringFree(LabelString);

  DisplayWeeklyViewNext_Button= XtVaCreateManagedWidget("DisplayWeeklyViewNext_Button",
							xmArrowButtonWidgetClass,
							DisplayWeeklyView_Form,
							XmNarrowDirection, XmARROW_RIGHT,
							XmNleftAttachment, XmATTACH_POSITION,
							XmNleftPosition,90,
							XmNrightAttachment, XmATTACH_POSITION,
							XmNrightPosition,100,
							XmNrightOffset,10,
							XmNtopAttachment, XmATTACH_POSITION,
							XmNtopPosition, 2,
							XmNbottomAttachment, XmATTACH_POSITION,
							XmNbottomPosition, 8,
							NULL,0);
  XtAddCallback(DisplayWeeklyViewNext_Button, XmNactivateCallback,  
		(XtCallbackProc)  DisplayNextWeek, NULL);

  


  DisplayWeeklyView_Separator = XtVaCreateManagedWidget("DisplayWeeklyView_Separator",
							xmSeparatorWidgetClass,
							DisplayWeeklyView_Form,
							XmNleftAttachment, XmATTACH_FORM,
							XmNrightAttachment, XmATTACH_FORM,
							XmNtopAttachment, XmATTACH_POSITION,
							XmNtopPosition, 10,
							XmNbottomAttachment, XmATTACH_POSITION,
							XmNbottomPosition, 12,
							NULL,0);

  DisplayWeeklyView_SW = XtVaCreateManagedWidget("DisplayWeeklyView_SW",
						 xmScrolledWindowWidgetClass, 
						 DisplayWeeklyView_Form,
						 XmNleftAttachment, XmATTACH_FORM,
						 XmNleftOffset, 10,
						 XmNrightAttachment, XmATTACH_FORM,
						 XmNrightOffset, 10,
						 XmNtopAttachment, XmATTACH_POSITION,
						 XmNtopPosition, 12,
						 XmNbottomAttachment, XmATTACH_POSITION,
						 XmNbottomPosition, 92,
						 XmNscrollBarPlacement, XmBOTTOM_LEFT,
						 XmNvisualPolicy, XmVARIABLE,
/* 						 XmNscrollBarDisplayPolicy, XmSTATIC, */
						 XmNscrollingPolicy, XmAUTOMATIC,
						 NULL,0);

  DisplayWeeklyView_DA = XtVaCreateManagedWidget("DisplayWeeklyView_DA",
						 xmDrawingAreaWidgetClass, 
						 DisplayWeeklyView_SW,
						 NULL,0);
  XtAddCallback(DisplayWeeklyView_DA, XmNinputCallback,  
		(XtCallbackProc)  DisplaySelectedDay, NULL);

  DisplayWeeklyView_Separator = XtVaCreateManagedWidget("DisplayWeeklyView_Separator",
							xmSeparatorWidgetClass,
							DisplayWeeklyView_Form,
							XmNleftAttachment, XmATTACH_FORM,
							XmNrightAttachment, XmATTACH_FORM,
							XmNtopAttachment, XmATTACH_POSITION,
							XmNtopPosition, 92,
							XmNbottomAttachment, XmATTACH_POSITION,
							XmNbottomPosition, 94,
							NULL,0);
  
  LabelString = XmStringCreate("Close", XmSTRING_DEFAULT_CHARSET),
  DisplayWeeklyViewClose_Button = XtVaCreateManagedWidget("DisplayWeeklyViewClose_Button",
							  xmPushButtonWidgetClass,
							  DisplayWeeklyView_Form,
							  XmNlabelString, LabelString,
							  XmNtopAttachment, XmATTACH_WIDGET, 
							  XmNbottomAttachment, XmATTACH_FORM,
							  XmNbottomOffset, 10,
							  XmNleftAttachment, XmATTACH_POSITION,
							  XmNleftPosition,45,
							  XmNtopAttachment, XmATTACH_POSITION,
							  XmNtopPosition, 94,
							  XmNbottomAttachment, XmATTACH_POSITION,
							  XmNbottomPosition, 100,
							  NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(DisplayWeeklyViewClose_Button, XmNactivateCallback, 
                (XtCallbackProc) DisplayWeeklyView_Close, DisplayWeeklyView_Popup );
  
  WM_DELETE_WINDOW = XmInternAtom(XtDisplay(DisplayWeeklyView_Popup),
				  "WM_DELETE_WINDOW",False);
  XmAddWMProtocolCallback(DisplayWeeklyView_Popup,WM_DELETE_WINDOW,
			  (XtCallbackProc)DisplayWeeklyView_Close,DisplayWeeklyView_Popup);


  XtRealizeWidget(DisplayWeeklyView_Popup);

  XtVaGetValues(DisplayWeeklyView_DA,
		XmNwidth, &Width,
		XmNheight, &Height,
                NULL,0);
  DisplayWeeklyView_Pixmap = XCreatePixmap(XtDisplay(DisplayWeeklyView_DA),
					   XtWindow(DisplayWeeklyView_DA),
					   Width,
					   Height,
					   DefaultDepthOfScreen(XtScreen(DisplayWeeklyView_DA)));
  
/*  XtAddEventHandler(DisplayWeeklyView_DA,ExposureMask,False,
                    (XtEventHandler) DrawWeeklyCalendar, NULL );
*/

  DrawWeeklyCalendar();
}


